# $Revision: 1.109.2.1 $, $Date: 2005-06-25 22:58:13 $
Summary:	C library optimized for size
Summary(pl):	Biblioteka C zoptymalizowana na rozmiar
Name:		uClibc
Version:	0.9.27
Release:	2
Epoch:		2
License:	LGPL
Group:		Libraries
Source0:	http://uclibc.org/downloads/%{name}-%{version}.tar.bz2
# Source0-md5:	6250bd6524283bd8e7bc976d43a46ec0
Patch0:		%{name}-newsoname.patch
Patch1:		%{name}-alpha.patch
Patch2:		%{name}-toolchain-wrapper.patch
Patch3:		%{name}-targetcpu.patch
Patch4:		%{name}-O_DIRECT.patch
Patch5:		%{name}-sparc.patch
URL:		http://uclibc.org/
BuildRequires:	gcc >= 3.0
BuildRequires:	sed >= 4.0
BuildRequires:	which
ExclusiveArch:	alpha %{ix86} ppc sparc sparc64 sparcv9
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# note: the 2nd '\' is needed (some shell expansions?)
%define		TARGET_ARCH	%(echo %{_target_cpu} | sed -e 's/i.86\\|athlon\\|pentium./i386/;s/ppc/powerpc/')

%description
Small libc for building embedded applications.

%description -l pl
Maa libc do budowania aplikacji wbudowanych.

%package devel
Summary:	Development files for uClibc
Summary(pl):	Pliki dla programistw uClibc
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	binutils
Requires:	linux-libc-headers
%requires_eq	gcc

%description devel
Small libc for building embedded applications.

%description devel -l pl
Maa libc do budowania aplikacji wbudowanych.

%package static
Summary:	Static uClibc libratries
Summary(pl):	Biblioteki statyczne uClibc
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}
Provides:	libc-static

%description static
Static uClibc libratries.

%description static -l pl
Biblioteki statyczne uClibc.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

sed -e '
%ifarch sparc sparc64 sparcv9
	s/default TARGET_i386/default TARGET_sparc/
%endif
%ifarch alpha
	s/default TARGET_i386/default TARGET_alpha/
%endif
%ifarch ppc ppc64
	s/default TARGET_i386/default TARGET_powerpc/
%endif
	' extra/Configs/Config.in > Conf.in.tmp
mv -f Conf.in.tmp extra/Configs/Config.in

grep -v 'HAVE_NO_SHARED\|ARCH_HAS_NO_LDSO' extra/Configs/Config.sparc > C.tmp
mv -f C.tmp extra/Configs/Config.sparc
grep -v 'HAS_NO_THREADS' extra/Configs/Config.alpha > C.tmp
mv -f C.tmp extra/Configs/Config.alpha

%ifarch sparc sparc64 sparcv9
ln -sf /usr/include/asm-sparc include/asm-sparc
ln -sf /usr/include/asm-sparc64 include/asm-sparc64
%{__perl} -pi -e 's/^(rm.*asm)\*/$1/' extra/scripts/fix_includes.sh
%endif

%build
%{__make} defconfig \
	TARGET_ARCH="%{TARGET_ARCH}" \
	TARGET_CPU="%{_target_cpu}" \
	KERNEL_SOURCE=%{_prefix} \
	HOSTCC=%{__cc} \
	HOSTCFLAGS="%{rpmcflags} %{rpmldflags}" \
	OPTIMIZATION="%{rpmcflags} -Os" \
	CC="%{__cc}"

mv -f .config .config.tmp
sed -e 's/^.*UCLIBC_HAS_IPV6.*$/UCLIBC_HAS_IPV6=y/;
	s/^.*DO_C99_MATH.*$/DO_C99_MATH=y/;
	s/^.*UCLIBC_HAS_RPC.*/UCLIBC_HAS_RPC=y\n# UCLIBC_HAS_FULL_RPC is not set/
	' .config.tmp > .config
%{?debug:echo 'DODEBUG=y' >> .config}
%{?debug:echo 'SUPPORT_LD_DEBUG=y' >> .config}

# force regeneration after .config changes
rm -f include/bits/uClibc_config.h

# note: defconfig and all must be run in separate make process because of macros
%{__make} \
	TARGET_ARCH="%{TARGET_ARCH}" \
	TARGET_CPU="%{_target_cpu}" \
	KERNEL_SOURCE=%{_prefix} \
	HOSTCC=%{__cc} \
	HOSTCFLAGS="%{rpmcflags} %{rpmldflags}" \
	OPTIMIZATION="%{rpmcflags} -Os" \
	CC="%{__cc}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_bindir}

%{__make} install \
	NATIVE_CC=%{__cc} \
	NATIVE_CFLAGS="%{rpmcflags} %{rpmldflags}" \
	TARGET_ARCH="%{TARGET_ARCH}" \
	TARGET_CPU="%{_target_cpu}" \
	CC="%{__cc}" \
	PREFIX=$RPM_BUILD_ROOT

# these links are *needed* (by stuff in bin/)
for f in $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/bin/*; do
	mv -f $f $RPM_BUILD_ROOT%{_bindir}
	ln -sf ../../bin/`basename $f` $f
done

for f in c++ cc g++ gcc ld; do
	ln -sf /usr/bin/%{_target_cpu}-uclibc-$f \
		$RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/bin/$f
done

rm -rf $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/include/{linux,asm*}
ln -sf /usr/include/asm $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/include/asm
%ifarch sparc sparc64 sparcv9
ln -sf /usr/include/asm-sparc $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/include/asm-sparc
ln -sf /usr/include/asm-sparc64 $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/include/asm-sparc64
%endif
ln -sf /usr/include/linux $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/include/linux
rm $RPM_BUILD_ROOT/%{_prefix}/*-linux-uclibc/usr/include/.cvsignore

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%dir %{_prefix}/*-linux-uclibc
%ifarch %{ix86} ppc sparc sparc64 sparcv9
%dir %{_prefix}/*-linux-uclibc/lib
%attr(755,root,root) %{_prefix}/*-linux-uclibc/lib/*.so*
%endif

%files devel
%defattr(644,root,root,755)
%doc README TODO docs/threads.txt docs/uclibc.org/*.html
%attr(755,root,root) %{_bindir}/*
%{_prefix}/*-linux-uclibc/usr/lib/*.o
%dir %{_prefix}/*-linux-uclibc/usr
%dir %{_prefix}/*-linux-uclibc/usr/bin
%attr(755,root,root) %{_prefix}/*-linux-uclibc/usr/bin/*
%dir %{_prefix}/*-linux-uclibc/usr/lib
%ifarch %{ix86} ppc sparc sparc64 sparcv9
%attr(755,root,root) %{_prefix}/*-linux-uclibc/usr/lib/*.so
%endif
%{_prefix}/*-linux-uclibc/usr/include

%files static
%defattr(644,root,root,755)
%{_prefix}/*-linux-uclibc/usr/lib/lib*.a

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: uClibc.spec,v $
Revision 1.109.2.1  2005-06-25 22:58:13  ankry
- sparc fix from HEAD, rel. 2

Revision 1.109  2005/01/16 16:01:54  qboosh
- release 1

Revision 1.108  2005/01/16 11:32:28  qboosh
- added sparc patch (now builds again)
- removed asmflags patch (no longer needed)

Revision 1.107  2005/01/16 11:06:26  qboosh
- why no libpthread on alpha? it builds and is needed for librt

Revision 1.106  2005/01/15 22:39:19  qboosh
- updated to 0.9.27
- removed obsolete use-kernel-headers,sparc,linux2.6,gcc34,libgcc,return,sparc-ldso,g patches
- updated alpha,toolchain-wrapper,O_DIRECT patches

Revision 1.105  2004/10/10 11:38:02  havner
- rel 11 for gcc 3.3.5

Revision 1.104  2004/06/27 14:39:44  qboosh
- added O_DIRECT patch (sparc+ppc), release 10

Revision 1.103  2004/06/20 19:42:03  qboosh
- fixed asm includes with current llh on sparc*; release 9

Revision 1.102  2004/06/20 16:54:47  qboosh
- added g patch (avoid -ggdb build breakage); release 8

Revision 1.101  2004/06/19 19:48:34  averne
- rel7 for Ac

Revision 1.100  2004/05/30 11:21:42  pluto
- ops, cleanup.

Revision 1.99  2004/05/30 11:20:52  pluto
- invalid symlinks fixed.

Revision 1.98  2004/05/27 21:10:45  qboosh
- added sparc-ldso patch, release 6

Revision 1.97  2004/05/26 16:25:01  qboosh
- debug support at .config level

Revision 1.96  2004/05/25 17:21:08  qboosh
- added return patch (one more fix needed on sparc); release 5

Revision 1.95  2004/05/05 21:31:58  qboosh
- added libgcc patch (fixes __muldi3 issue on sparc); release 4

Revision 1.94  2004/05/05 09:37:30  pluto
- pentiumX support.

Revision 1.93  2004/05/05 09:35:27  pluto
- fixed %%files.
- removed cvs stuff.

Revision 1.92  2004/04/29 07:22:31  pluto
- gcc 3.4 fixes

Revision 1.91  2004/04/25 12:23:14  qboosh
- release 3: more fixes in alpha patch

Revision 1.90  2004/03/16 14:52:20  qboosh
- gcc 2.95 won't compile i386/crt*.S without nasty workarounds - BR gcc 3

Revision 1.89  2004/03/16 14:25:13  qboosh
- \n on right side of s requires sed 4.0

Revision 1.88  2004/03/16 13:40:39  qboosh
- cleanups

Revision 1.87  2004/03/03 21:15:11  andree
- added pentium3/i386 to TARGET_ARCH

Revision 1.86  2004/02/19 13:25:38  qboosh
- release 2: rebuild for gcc 3.3.3, strict deps

Revision 1.85  2004/02/09 13:45:57  pluto
- s/glibc-kernel-headers/linux-libc-headers/

Revision 1.84  2004/02/03 19:27:25  qboosh
- merged 0.9.26 from DEVEL; release 1

Revision 1.83.2.7  2004/02/01 00:43:45  qboosh
- release 0.2 (maybe 1 and merge?)

Revision 1.83.2.6  2004/01/31 23:24:41  qboosh
- enable shared lib on sparc (builds with sparc patch)

Revision 1.83.2.5  2004/01/31 23:19:49  qboosh
- added linux2.6 patch (for 2.6-based (g-)k-h); busybox builds now

Revision 1.83.2.4  2004/01/31 20:28:16  qboosh
- fixed config changes
- removed unneeded part of alpha patch, fixed files on alpha
- added ExclusiveArch (amd64 is not supported yet)

Revision 1.83.2.3  2004/01/31 18:33:13  qboosh
- revised patches:
  - lfs,no_bogus_gai probably obsolete
  - awk,gmon obsolete
  - asmflags is back (updated) - needed on i686
  - alpha,sparc are back (just apply cleanly!)
  - targetcpu is back (updated), link hacking no longer needed
- fixed config stuff (was heavily broken, totally broken on !x86)
- changed ugly dynamic linker path in toolchain-wrapper patch to more sane

Revision 1.83.2.2  2004/01/25 19:45:45  arekm
- now works, wow

Revision 1.83.2.1  2004/01/25 16:47:57  arekm
- update to 0.9.26 (builds but doesn't work; weird)

Revision 1.83  2004/01/24 23:26:40  arekm
- use external glibc-kernel-headers

Revision 1.82  2003/11/23 20:47:25  qboosh
- added sparc patch, fixed file lists for sparc

Revision 1.81  2003/11/23 19:42:53  qboosh
- added alpha and gmon patches, fixed files on alpha (no shared yet)
- copy non-existing sparc config from ppc
- why g+s for libm??? killed
- release 4

Revision 1.80  2003/10/25 20:21:12  arekm
- rel 3

Revision 1.79  2003/09/25 09:08:33  arekm
- fix what areq broke (always use /usr/include/{asm,linux}); rel 2

Revision 1.78  2003/09/13 13:59:29  areq
- 0.9.21

Revision 1.77  2003/09/11 17:23:19  mmazur
- uClibc rel 2; libtool rel 9
- fuck fuck fuck shit fuck fuck fuck... ppc builder was broken all the time
  and I hadn't noticed. FUCK

Revision 1.76  2003/09/03 13:29:24  mmazur
- killed _with_lfs bcond cause this is ac

Revision 1.75  2003/08/26 18:19:12  malekith
- yet another try on alpha

Revision 1.74  2003/08/26 18:15:59  malekith
- second try on alpha

Revision 1.73  2003/08/26 18:13:36  malekith
- first try on alpha

Revision 1.72  2003/08/15 20:31:26  arekm
- rebuild

Revision 1.71  2003/08/15 19:47:12  arekm
- use headers from /usr/include not from /usr/src/linux

Revision 1.70  2003/08/06 18:53:24  arekm
- change soname for libpthread.so; rel 0.2

Revision 1.69  2003/07/24 15:22:27  qboosh
- added asmflags, per-arch optimizations are back

Revision 1.68  2003/07/15 17:49:16  areq
- 0.9.20
- remove {rpmcflags} from OPTIMIZATION, build with -Os

Revision 1.67  2003/06/27 13:10:48  mmazur
- mass commit; now req: name = epoch:version

Revision 1.66  2003/05/28 13:02:24  malekith
- massive attack: source-md5

Revision 1.65  2003/05/25 06:27:30  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.64  2003/05/22 21:45:52  malekith
- release 0.4; %requires_eq gcc for devel

Revision 1.63  2003/05/22 21:13:42  malekith
- enable RPC
- release 0.3

Revision 1.62  2003/04/06 18:17:21  malekith
- added awk patch (now it builds fine for me)
- release 0.2

Revision 1.61  2003/04/02 22:44:56  qboosh
- started update to 0.9.19
- updated targetcpu patch, removed obsolete no_hardcoded_gcc, __thread patches
  and unneeded noinstalled patch

Revision 1.60  2003/03/27 21:53:05  malekith
- fix build on uClibc; release 0.2

Revision 1.59  2002/11/03 21:10:36  wolf
- CC=.. is also needed

Revision 1.58  2002/08/25 16:23:57  qboosh
- commented out lfs and no_bogus_gai patches - need check/update
- build different packages for i[356]86 (with a little help of targetcpu patch)
- noinstalled patch - don't require /usr/*-uclibc-linux/lib/crt0.o to build
- release 0.1 - please check commented patches

Revision 1.57  2002/07/16 21:51:53  kloczek
- start update to 0.9.12,
- removed outdated Makefile patch,
- enable shadow support.

Revision 1.56  2002/04/25 08:52:09  kloczek
- release 6: added Provides: libc-static in static subpackage.

Revision 1.55  2002/03/26 15:51:17  malekith
- ppc thinko fixed

Revision 1.54  2002/03/26 01:03:33  speedy
- sparc doesn't have ld.so

Revision 1.53  2002/03/18 18:34:32  malekith
- workaround for uClibc thinking ppc is called powerpc :)

Revision 1.52  2002/03/18 18:12:33  malekith
- br: which

Revision 1.51  2002/03/18 09:34:41  malekith
- rel 5
- updates lfs patch again

Revision 1.50  2002/03/15 14:40:22  malekith
- new version of lfs patch (always export {,f}open64 syscalls)
- added no_hardcoded_gcc patch -- allows build with itself
- rel 4

Revision 1.49  2002/03/08 15:13:19  malekith
- DO_C99_MATH = true (rint for iproute2)
- rel 3, stbr

Revision 1.48  2002/03/04 11:03:47  misiek
- now it builds on powerpc

Revision 1.47  2002/02/24 00:21:47  filon
- fixed inserted rubbish

Revision 1.46  2002/02/23 23:11:26  filon
- fix install section, tell make what TARGET_ARCH is
- release 2

Revision 1.45  2002/02/22 23:29:49  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.44  2002/02/05 18:14:40  kloczek
- typo.

Revision 1.43  2002/02/05 15:39:31  kloczek
- fixes for sparc: shared libraries are now builded but ld.so still not :(

Revision 1.42  2002/02/05 09:34:18  kloczek
- updated to 0.9.9 (new feactures and bugfixes),
- removed obsoleted setfsuid patch.

Revision 1.41  2002/02/02 03:22:37  kloczek
- release 5.

Revision 1.40  2002/02/02 02:20:29  misiek
- missing defattr for static subpackage

Revision 1.39  2002/01/23 16:14:53  malekith
- no_bogus_gai patch added (fixes openssh compilation)

Revision 1.38  2002/01/22 17:55:49  malekith
- more lfs fixes (new version of patch), finally builds

Revision 1.37  2002/01/22 14:26:52  malekith
- fixed lfs bcond

Revision 1.36  2002/01/22 12:49:59  malekith
- rel 4
- with lfs bcond added
- added patch to workaround uclibc bugs in lfs

Revision 1.35  2002/01/21 17:26:53  malekith
- rel 3
- added -Os to cflags
- added links in /usr/*-uclibc/usr/bin

Revision 1.34  2002/01/18 02:15:14  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.33  2002/01/05 16:51:51  kloczek
- release 2.

Revision 1.32  2002/01/04 16:40:38  malekith
- don't create /usr/bin/bin

Revision 1.31  2002/01/04 16:31:20  malekith
- s/perl/sed
- include .html docs

Revision 1.30  2002/01/03 21:51:31  kloczek
- enable ipv6 support.

Revision 1.29  2002/01/03 21:34:45  kloczek
- fix in %build,
- added gcc and binutils to Requires rules for devel subpackage.

Revision 1.28  2002/01/03 21:21:47  kloczek
- added Makefile patch which allow build uClibc from account with gid!=uid.

Revision 1.27  2002/01/03 21:10:17  kloczek
- updated to 0.9.8 (Epoch: 1),
- Added Souce url and updated URL,
- package completly reorganized.

Revision 1.26  2001/12/19 13:58:18  qboosh
- cosmetics, pl translations

Revision 1.25  2001/10/05 07:55:43  kloczek
- release 8,
- spec adapterized.

Revision 1.24  2001/10/04 11:22:58  misiek
- more arch fixes

Revision 1.23  2001/10/04 11:05:21  misiek
- this package must be arch independent

Revision 1.22  2001/08/30 22:55:51  filon
- updated to 20010826
- removed ipv6 patch, already in sources
- it builds again

Revision 1.21  2001/08/19 20:24:29  saq
- using %%_kernelsrcdir
- WARNING: doesn't build

Revision 1.20  2001/06/20 10:37:23  malekith
- new version of ipv6 patch

Revision 1.19  2001/06/19 10:27:01  malekith
- added v6 resolver patch
- rel 6

Revision 1.18  2001/06/16 10:57:38  klakier
- rel 5

Revision 1.17  2001/06/16 10:57:13  klakier
- added forgotten libdl.a
- fixed perms on libs

Revision 1.16  2001/06/10 14:26:10  kloczek
- cosmetics.

Revision 1.15  2001/06/08 15:01:39  wiget
linux-devel-BOOT is dead

Revision 1.14  2001/05/22 22:51:06  klakier
- added -m386 for BOOT

Revision 1.13  2001/05/21 19:00:44  klakier
- rel 3
- enabled rpc

Revision 1.12  2001/05/21 18:33:19  klakier
- ver 20010521

Revision 1.11  2001/05/16 14:52:33  klakier
- remove CVS dirs

Revision 1.10  2001/05/16 14:39:54  klakier
- I hate symlinks, wrrrr

Revision 1.9  2001/05/16 14:02:28  klakier
- rel 2

Revision 1.8  2001/05/16 13:59:47  klakier
- cp -pr seems to cause portability problems

Revision 1.7  2001/05/16 09:21:38  malekith
- added setfsuid patch

Revision 1.6  2001/04/19 05:18:25  kloczek
- only adapterized.

Revision 1.5  2001/04/15 13:30:07  klakier
- BuildRequires linux-devel-BOOT

Revision 1.4  2001/04/13 12:55:59  klakier
- forgot to add crt0.o to files

Revision 1.3  2001/04/13 12:40:39  klakier
- fixed requires

Revision 1.2  2001/04/13 12:28:39  klakier
- devel -> devel-BOOT

Revision 1.1  2001/04/13 12:27:23  klakier
- TODO main package ie empty (I only need -BOOT)
